
function ANTIS = AntisKo(M, tulostus);
%antisymmetrisyystesti:	function ANTIS = AntisKo(M, tulostus);
%	miss
%	M		= relaation nelimuotoinen 0-1-matriisi
%	tulostus	= optionaalinen, esim. merkkijono tyhje ' '
%			jos esiintyy, tulostetaan tieto mys tekstin.
%	Tarkastaa, onko matriisin M edustama relaatio antisymmetrinen.
%	Palauttaa arvon 1, jos on, muutoin arvon 0.
%	arvo 1 <=> diagonaalin eri puolilla ei ole symmetrisesti ykksi.
%	Voidaan vaikkapa tarkastaa, ett matriisissa ja sen transpoosissa ei ole
%	diagonaalin ulkopuolella samoilla kohtaa ykksi, ts. ett 
%	M & M' on nollia, paitsi diagonaalilla samat kuin matriisissa M.
%	KOODI ANTIS = isequal(M&M', diag(diag(M)));
%	[ tai ANTIS = all(all( (M&M') == diag(diag(M)) )); ]

%	Martti E. Pesonen 25.5.1991, 25.9.2000 ja 26.10.2004

M = logical(M);
ANTIS = isequal(M & M', diag(diag(M)));
if (nargin > 1)
	if ANTIS
   	disp('antisymmetrinen')
	end;
end;
