
function SAR = SatAntis(n, prosenttia);
% function SAR = SatAntis(n, prosenttia);
%	miss
%	n 	   = relaation nelimatriisin dimensio
%	prosenttia = optionaalinen, jos esiintyy, tulkitaan ykksten 
%		     prosentuaaliseksi osuudeksi arvottaessa
%		     'raakamatriisia' (oletusarvo 50)
% Muodostaa "satunnaisen" antisymmetrisen relaation (n x n)-matriisin SAR.
% Muodostetaan ensin satunnaisrelaatio, joka antisymmetrisoidaan.
% HUOMAUTUS! Antisymmetrinen (n x n)-relaatio voi sislt ENINTN
% (1/2)*n*(n+1) ykkst, suurilla n siis hiukan yli puolet.
% Tuloksessa on yleens vhemmn kuin 'prosenttia' ykksi.
% Kytt: SatRel.m, AntisymmSoi.m
% Martti E. Pesonen 20.2. 1991 ja 26.10.2004

if (nargin == 1) prosenttia = 50; end	% oletusarvo
SAR = SatRel(n,n,prosenttia);	        % arvotaan raakamatriisi
SAR = AntisymmSoi(SAR);
