
function [HV, HK] = AnimoiHK(M, aika);
%Hamiltonin ketjun etsinnn animointi: function [HV, HK] = AnimoiHK(M, aika);
%	miss
%	M	= verkon (symmetrinen) matriisi
%	aika	= optionaalinen, piirron hidastus sekunteina.
%		Jos ei esiinny, ENTERill psee aina eteenpin.
%		Peruutusta tehdn automaattisesti.
%	Animoi Hamiltonin ketjun etsimist, lhtien solmusta 1.
%	Kytt: PIIRSTON ym. piirtofunktiot

%	Martti E. Pesonen 27.2.1991 ja 17.10.2000

PiirSTon(M);disp('VERKON PIIRTO: klikkaa kuva (Figure) esiin ja paina ENTER');pause
if (nargin == 1) aika = 1; end
M = sign(M - diag(diag(M))); 
n = max(size(M));
if (n == 1) 
   HK = 1; HV = 1; ketju = [1]; 
   disp('Triviaali tapaus, yksisolmuinen verkko!')
	else
	HK = [];
	HV = 0;      
   ketju = [1];  ind = ones(1,n);
	while ~isempty(ketju)
		solmu = ketju(length(ketju));	% ketjun viimeinen
  		vierekkaiset = find(M(solmu,:));	% viereiset solmut
  		vierekkaisia = sum(M(solmu,:));	% niiden mr
  		valmis = 0;
  		while ((ind(solmu) <= vierekkaisia) & ~valmis)
    		seuraava = vierekkaiset(ind(solmu));
    		if ~any(ketju == seuraava)
			valmis = 1;
         PiirKaar(M, 1, [solmu seuraava], '--g'); 
         if (nargin == 2), pause(aika), else pause, end;
    		end; %if
    		ind(solmu) = ind(solmu) + 1;
  		end; %while
  		if valmis
    		ketju = [ketju seuraava];
   		else
    		pituus = length(ketju);
    		if (pituus > 1)
				PiirKaar(M, 1, ketju(1,(pituus-1):pituus), '-b'), pause(aika)
    		end
    		ketju = ketju(1,1:(pituus-1));
    		ind(solmu) = 1;
  		end
  		if (length(ketju) == n)
    		if M(seuraava,1)
      		PiirKaar(M, 1, [seuraava 1], '-w');
      		HV = 1; HK = [ketju ketju(1)]; ketju = [];
     			else
      		HK = ketju;
    		end
  		end
	end
	if HV 
   	disp('Hamiltonin verkko, ers suljettu Hamiltonin ketju on:'); disp(HK)
  		else 
    	if ~isempty(HK)
			disp('Ei Hamiltonin verkko, avoin Hamiltonin ketju:');disp(HK)
      	else
			disp('Ei ole Hamiltonin ketjuja.')
    	end
	end
end
