
function L = Listaksi(M, tulostus);
%verkko listana:	function L = Listaksi(M, tulostus);
%	miss
%	M = verkon (symmetrinen) matriisi
%	tulostus = optionaalinen, esim. merkkijono ''
%		   jos esiintyy, tulostetaan "lista"
% Suuntaamattomalle verkolle.
% Verkon yhteysmatriisin perusteella muodostetaan matriisi L, jonka
%	1. sarake = solmujen numerot 1,...,n
%	solmun k jlkeen on lueteltu solmut, joihin k:sta on kaari.
% Riveill on tarpeellinen mr nollia.

%	Martti E. Pesonen 6.3.1991 ja 25.9.2000

[n,m] = size(M); kaaria_rivilla = sum(M');
sarakkeita = max(kaaria_rivilla); L = zeros(n,sarakkeita);
if sarakkeita
    for rivi = 1:n
       if kaaria_rivilla(rivi)
	   apu = [];
	   for sarake = 1:n
	       apu = [apu (sarake*ones(1,M(rivi,sarake)))];
	   end
	   L(rivi,1:kaaria_rivilla(rivi)) = apu;
	end
    end
    L = [(1:n)' L];
    if (nargin == 2)
	disp('Verkko "listana" (1. sarake = lhtsolmut):'); disp(L)
    end
end
