
function PiirKaar( M, kaaret, paat, vari);
%piirto, suuntaamattoman verkon kaaret: function PiirKaar( M, kaaret, paat, vari);
%	miss
%	M	= verkon matriisi
%	kaaret	= piirrettvien kaarten vektori [k1 k2 ...kp] 
%	paat	= kaaren pt muodossa [i j]
%	vari	= optionaalinen, piirtovri,
%		oletusvri = punainen viiva
%	Suuntaamattomalle verkolle.
%	Piirt annetut kaaret solmujen i -- j vlille. 'Kaaret' on kaikkien
%	kaarten numeroiden [1 2 3...M(i,j)] osavektori, esim. [2 4 7].

%	Martti E. Pesonen 25.5.1991 ja 25.9.2000

oletusvari = '-r';
ympsade = 1; smaxsade = 0.1*ympsade; numetkerr = (ympsade + 0.2)/ympsade;
segmsuhtkork = 1/6; jako = 10;
if (nargin < 4) vari = oletusvari; end
n	= max(size(M));		kaari_lkm = length(kaaret);
kaaret	= sort(kaaret);		paat	= sort(paat);
kulmat 	= (paat - 1) * (2*pi)/n + pi/2;
xt 	= ympsade*cos(kulmat);		yt = ympsade*sin(kulmat);
if (kaaret(1) == 1)
  plot( xt, yt, vari);
  kaaret = kaaret(2:kaari_lkm);
  kaari_lkm = kaari_lkm - 1;			% jana pois laskuista
end
if (kaari_lkm >= 1)
  lkm		= M(paat(1), paat(2)) - 1;
  z1		= [xt(1) yt(1)];		% solmut tasossa
  z2		= [xt(2) yt(2)];
  etaisyys	= norm(z2 - z1);		% solmujen vlimatka
  korkeudet	= (segmsuhtkork * etaisyys / lkm)*(0:lkm);
  a		= (z2 - z1)/etaisyys;	% solmujen vlin yksikkvektori
  b		= [a(2) -a(1)];	% kohtisuora yksikkvektori
  alfa		= atan((2*korkeudet)/etaisyys);
  gamma		= (pi/2) - 2*alfa;
  kateet	= (etaisyys/2) * tan(gamma);
  keskus	= (z1 + (etaisyys/2)*a)';
  delta		= (pi/2) - gamma;
  parilliset	= kaaret(~rem(kaaret,2));
  if ~isempty(parilliset)
    kpt		= keskus*ones(1, max(size(parilliset))) - b'*kateet(parilliset);
    sateet	= kateet(parilliset) + korkeudet(parilliset);
    deltat	= delta(parilliset);
    valit	= 2*deltat/jako;
    fii		= atan2( b(2), b(1));  
    alut	= fii - deltat;
    fiit	= ones(jako+1,1)*alut + (0:jako)'*valit;
    Xt = (cos(fiit)).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(1,:);
    Yt = (sin(fiit)).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(2,:); 
    plot( Xt, Yt, vari)
  end
  parittomat = kaaret(find(rem(kaaret,2)));
  if ~isempty(parittomat)
    kpt		= keskus*ones(1, max(size(parittomat))) + b'*kateet(parittomat);
    sateet	= kateet(parittomat) + korkeudet(parittomat);
    deltat	= delta(parittomat);
    valit	= 2*deltat/jako;
    fii		= atan2(-b(2),-b(1));
    alut	= fii + deltat;
    fiit	= ones(jako+1,1)*alut - (0:jako)'*valit;
    Xt = cos(fiit).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(1,:);
    Yt = sin(fiit).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(2,:); 
    plot( Xt, Yt, vari)
  end
end    
