
function PiirSTon( M, vari);
%piirto, suuntaamaton verkko:	function PiirSTon( M, vari);
%	miss
%	M	= verkon (symmetrinen) matriisi
%	vari	= optionaalinen, piirtovri, vain entiseen kuvaan piirrossa
%			jos esiintyy, piirretn kaaret vrill 'vari'
%			oletusvri = punainen viiva, eli vari = '-r'
%	Suuntaamattomalle verkolle.
%	Piirt
%		solmut 1-steiselle ympyrn kehlle, 
%		silmukat solmua sivuaviksi ympyriksi,
%		1. kaaret janoiksi, seuraavat ympyrn kaariksi.

%	Martti E. Pesonen 25.5.1991 ja 25.9.2000

if Tarkastu(M),
xminmax = [-1.5 1.9]; yminmax = [-1.3 1.3]; oletusvari = '-r';
ympsade = 1; smaxsade = 0.1*ympsade; numetkerr = (ympsade + 0.2)/ympsade;
segmsuhtkork = 1/6; jako = 10;
if (nargin == 1)
   clf, hold off; axis([xminmax yminmax]); hold on; 
   axis('off'); vari = oletusvari;
end
n	= max(size(M));
kulmat	= ((1:n) - 1) * (2*pi)/n + pi/2;	% kaikkien n solmun kulmat
xt	= ympsade * cos(kulmat);		% niiden koordinaatit
yt	= ympsade * sin(kulmat);
plot( xt, yt, 'ow')
for i = 1:n   text( numetkerr*xt(i), numetkerr*yt(i), int2str(i),'FontSize',16);  end
solmut = find(diag(M))';			% solmut, joissa silmukoita
for i = solmut
  lkm		= M(i,i);
  sateet	= (smaxsade/lkm) * (1:lkm);
  kpt		= [xt(i); yt(i)] * (1 + sateet/ympsade);
  kkulmat	= (0:jako)'*(2*pi/jako);
  plot( cos(kkulmat)*sateet + ones(size(kkulmat))*kpt(1,:),...
	sin(kkulmat)*sateet + ones(size(kkulmat))*kpt(2,:), vari)
end
M		= triu(M) - diag(diag(M));
lahtosolmut	= find(any(M'));
for i = lahtosolmut
  J = find(M(i,:));		m = max(size(J));
  plot( [ones(1,m)*xt(i); xt(J)], [ones(1,m)*yt(i); yt(J)], vari)
end
M = M - (M > 0);
lahtosolmut = find(any(M'));
for i = lahtosolmut 
  tulosolmut = find(M(i,:));
  for j = tulosolmut
    lkm = M(i,j);
    z1  = [xt(i) yt(i)];	z2 = [xt(j) yt(j)];
    etaisyys	= norm(z2 - z1);	% solmujen vlimatka
    korkeudet	= (segmsuhtkork * etaisyys / lkm) * (0:lkm);
    alfa	= atan((2*korkeudet)/etaisyys);
    gamma	= (pi/2) - 2*alfa;
    kateet	= (etaisyys/2) * tan(gamma);	
    a		= (z2 - z1)/etaisyys;		% solmujen vlin yksikkvektori
    b		= [a(2) -a(1)];			% kohtisuora yksikkvektori
    alfa	= atan((2*korkeudet)/etaisyys);
    gamma	= (pi/2) - 2*alfa;  delta = (pi/2) - gamma;
    kateet	= (etaisyys/2) * tan(gamma);
    keskus	= (z1 + (etaisyys/2)*a)';
    parilliset	= 2:2:(lkm+1);
    if ~isempty(parilliset)
      kpt	= keskus*ones(1, max(size(parilliset))) - b'*kateet(parilliset);
      sateet	= kateet(parilliset) + korkeudet(parilliset);
      deltat	= delta(parilliset);
      valit	= 2*deltat/jako;
      fii	= atan2( b(2), b(1));
      alut	= fii - deltat;
      fiit	= ones(jako+1,1)*alut + (0:jako)'*valit;
      Xt = (cos(fiit)).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(1,:);
      Yt = (sin(fiit)).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(2,:); 
      plot( Xt, Yt, vari)
    end
    parittomat = 3:2:(lkm+1);
    if ~isempty(parittomat)
      kpt	= keskus*ones(1, max(size(parittomat))) + b'*kateet(parittomat);
      sateet	= kateet(parittomat) + korkeudet(parittomat);
      deltat	= delta(parittomat);
      valit	= 2*deltat/jako; 
      fii	= atan2(-b(2),-b(1));
      alut	= fii + deltat;
      fiit	= ones(jako+1,1)*alut - (0:jako)'*valit;
      Xt = cos(fiit).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(1,:);
      Yt = sin(fiit).*(ones(jako+1,1)*sateet) + ones(jako+1,1)*kpt(2,:);
      plot( Xt, Yt, vari)
    end
  end
end
else
   disp('Matriisi ei ole suuntaamattoman verkon matriisi.')
end;
