
function  PiirSilm( M, silmukat, solmu, vari);
%piirto, suuntaamattoman verkon silmukat:	function PiirSilm( M, silmukat, solmu, vari);
%	miss
%	M	= verkon (symmetrinen) matriisi
%	silmukat= piirrettvien silmukoiden vektori
%	solmu	= solmun numero
%	vari	= optionaalinen, piirtovri,
%			oletusvri = punainen ympyr
%	Suuntaamattolle verkolle.
%	Piirt solmua sivuavat silmukat. Parametri 'silmukat' on vektori,
%	joka kertoo, mitk silmukoista [1 2 3 ... M(solmu,solmu)] piirretn;
%	esim. [2 3 6].

%	Martti E. Pesonen 25.5.1991 ja 25.9.2000

oletusvari = '-r'; ympsade = 1; smaxsade = 0.1*ympsade; jako = 10;
if (nargin < 4) vari = oletusvari; end
n	= max(size(M));
kulma	= (solmu - 1) * (2*pi)/n + pi/2;
xt	= ympsade * cos(kulma);		% niiden koordinaatit
yt	= ympsade * sin(kulma);
lkm	= M(solmu,solmu);
sateet	= (smaxsade/lkm) * silmukat;
kpt	= [xt; yt] * (1 + sateet/ympsade);
kkulmat	= (0:jako)'*(2*pi/jako);
  plot( cos(kkulmat)*sateet + ones(size(kkulmat))*kpt(1,:),...
	sin(kkulmat)*sateet + ones(size(kkulmat))*kpt(2,:), vari)
