
function TULOS = Tarkastu(M, tulostus);
%tarkastus, suuntaamaton verkko:	function TULOS = Tarkastu(M, tulostus);
%	miss
%	M	= tarkastettava verkon matriisiehdokas
%	tulostus= optionaalinen, jokin merkkijono, esim. ''
%		  esiintyminen aiheuttaa tiedon tulostamisen tekstin
%	Suuntaamattomalle verkolle.
%	Tarkastaa, onko matriisi kelvollinen vai ei, ts.
%	onko kyseess symmetrinen nelimatriisi, jonka alkiot ovat 
%	ei-negatiivisia kokonaislukuja: 
%	TULOS = 0, jos ei ole kelvollinen, ts. 
%	TULOS = 1, jos matriisi on kelvollinen suuntaamattoman verkon matriisiksi.

%	Martti E. Pesonen 6.3.1991 ja 30.9.2002

TULOS = 0;
epatyhja= ~isempty(M);
if epatyhja
    looginen = islogical(M);
    if ~looginen 
        [n,m]	= size(M);
        nelio	= (n == m);
        if nelio 
            symm	= all(all(M == M'));
            einegat	= all(all(M >= 0));
            kokon	= ~any(any(M - round(M)));
            TULOS	= symm & einegat & kokon;
        end;     
    end;
end;
if  (nargin == 2)
    if ~epatyhja
        disp('Verkon matriisi ei saa olla tyhj.');          
        else
        if looginen
            display('Logiikkamatriisi, muunna numeeriseksi, esim. M = +M.')
            else
            if ~nelio
                disp('Verkon matriisin tytyy olla nelimatriisi.')
                else
                if ~symm
                    disp('Suuntaamattoman verkon matriisin pit olla symmetrinen.')
                    disp('Voit symmetrisoida matriisin funktiolla SymSoi.')
                end
                if (~einegat | ~kokon)
                    disp('Verkon matriisissa on oltava vain ei-negatiivisia kokonaislukuja.')
                end
            end    
        end
    end
end
